diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/CodeResourceReceiver.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/CodeResourceReceiver.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/CodeResourceReceiver.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/CodeResourceReceiver.java	2017-09-15 12:01:31.827634000 +0900
@@ -0,0 +1,444 @@
+
+package com.android.server.remote;
+
+import android.app.ActivityThread;
+import android.content.Context;
+import android.content.pm.IPackageManager;
+import android.os.AsyncTask;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.DexCode;
+import android.service.remote.IRemoteService;
+import android.service.remote.ResourceAapt;
+import android.service.samd.ISAMDService;
+import android.util.Log;
+
+import com.android.server.samd.SAMDService;
+
+import java.io.BufferedInputStream;
+import java.io.BufferedWriter;
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileOutputStream;
+import java.io.FileWriter;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.io.OutputStream;
+import java.net.Socket;
+import java.util.ArrayList;
+
+
+public class CodeResourceReceiver implements Runnable {
+    private static final String TAG = "Data Receiver";
+
+    private Socket clientSocket;
+    private ObjectOutputStream outToClient;
+    private AppendingObjectOutputStream oos;
+    private ObjectInputStream inFromClient;
+    private int hashValue;
+    private int sourceDevice;
+
+    // private ObjectOutputStream
+    private final Context mContext;
+    private final String mPackageName;
+
+    private final IRemoteService mRemoteService;
+
+    public CodeResourceReceiver(Context context, Socket clientSocket, int _sourceDevice) {
+        mContext = context;
+        mPackageName = ActivityThread.currentPackageName();
+
+
+        this.clientSocket = clientSocket;
+        Log.d(TAG, "request from(for data): "
+                + this.clientSocket.getInetAddress().getHostAddress());
+        hashValue = clientSocket.getInetAddress().getHostAddress().hashCode();
+        this.sourceDevice = _sourceDevice;
+
+        mRemoteService = IRemoteService.Stub.asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+        try {
+
+            outToClient = new ObjectOutputStream(this.clientSocket.getOutputStream());
+            oos = new AppendingObjectOutputStream(this.clientSocket.getOutputStream());
+            inFromClient = new ObjectInputStream(new BufferedInputStream(
+                    this.clientSocket.getInputStream()));
+//            inFromClient = new ObjectInputStream(
+//                    this.clientSocket.getInputStream());
+
+
+        } catch (IOException e) {
+            e.printStackTrace();
+        }
+    }
+
+    @Override
+    public void run() {
+        try {
+            while (!Thread.currentThread().isInterrupted()) {
+                Object input = inFromClient.readObject();
+                if (input instanceof String) {
+                    Log.d(TAG, "String: " + input.toString());
+                    if (input.toString().equals("DataHello")) {
+                        Log.d("sbjsbjsbjsbjsbj", "sbjsbjsbjsbjsbj codeResourceReceiver");
+
+                        RemoteService.deviceToOutputforData.
+                                put(this.clientSocket.getInetAddress().getHostAddress(), oos);
+                        RemoteService.deviceToInputforData.put(this.clientSocket.getInetAddress().getHostAddress(),
+                                inFromClient);
+
+                        Log.d(TAG, "just got Hellooo from client (for data)"
+                                + RemoteService.mSensorHandles.toString());
+                        Log.d(TAG, "SBJJJJJJJJJJJJJJJJJ");
+                        oos.writeObject("DataGooooood");
+                        oos.flush();
+                        Log.d(TAG, "SBJJJJJJJJJJJJJJJJJ");
+                    }
+                } else if (input instanceof ResourceAapt) {
+                    ResourceAapt resourceAapt = (ResourceAapt) input;
+                    SAMDService.remote_device_number = (int) resourceAapt.getPara().get(0);
+                    ArrayList<String> addResourcesPerActivity = new ArrayList<String>();
+                    Log.d("uuuuuuu_SAMDVSAPK", "multiDexTransfer getMultiDex receive : " + (String) resourceAapt.getPara().get(1));
+                    //File dexFiles = new File("/data/collaboroid/agent/dex/" + (String) request.getPara().get(j) + "_classes.dex");
+                    //DEX
+                    String dexFileName = (String) resourceAapt.getPara().get(1);
+                    Log.d("samd experiment","receive Dex & Resources : " + dexFileName);
+                    //PRE RESOURCES
+                    int preResourcesNum = (int) resourceAapt.getPara().get(3);
+                    //REAL RESOURCES
+                    int resourcesNum = (int) resourceAapt.getPara().get(4+preResourcesNum);
+
+                    File dexFiles = new File("/collaboroid/agent/dex/" + dexFileName + "_classes.dex");
+                    try {
+                        FileOutputStream fileOutputStream = new FileOutputStream(dexFiles);
+                        fileOutputStream.write((byte[]) resourceAapt.getPara().get(2));
+                        fileOutputStream.flush();
+                        fileOutputStream.close();
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+                    for (int i = 0, j = 4; i < preResourcesNum; i++, j ++) {
+                        //SBJ_A/res/drawable/a.png?
+                        String resDirectory = (String) resourceAapt.getPara().get(j);
+                        //add resources
+                        File src = new File("collaboroid/agent/activity_res/"+resDirectory);
+                        String dstResDirectory = resDirectory.replace(resDirectory.split("\\/")[0],dexFileName);
+                        File dst = new File("collaboroid/agent/activity_res/"+dstResDirectory);
+                        copy(src, dst);
+                        addResourcesPerActivity.add(resDirectory);
+                    }
+                    for (int i = 0, j = 4+preResourcesNum+1; i < resourcesNum; i++, j += 2) {
+                        Log.d("uuuuuuu_SAMDVSAPK", "getResourcesLR receive : " + (String) resourceAapt.getPara().get(j));
+                        String activityResDirectory = (String) resourceAapt.getPara().get(j);
+                        //add resources
+                        addResourcesPerActivity.add(activityResDirectory);
+                        //create directory
+                        createDirAndFile(activityResDirectory,(byte[]) resourceAapt.getPara().get(j + 1));
+                    }
+                    AndroidManifestDummy(dexFileName);
+
+                    File f = new File("collaboroid/agent/activity_res/"+dexFileName+"/assets");
+                    if(f.exists()){
+                        Log.d("samd experiment","aapt package start["+dexFileName+"]");
+                        IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+                        try {
+                            pm.aaptPackageWithAssets("/collaboroid/agent/activity_res/"+dexFileName+"/res",
+                                    "collaboroid/agent/activity_res/"+dexFileName+"/assets",
+                                    "/collaboroid/agent/activity_res/"+dexFileName+"/AndroidManifest.xml",
+                                    "/collaboroid/agent/activity_res/"+dexFileName+"/abc.apk");
+                        } catch (RemoteException e) {
+                            e.printStackTrace();
+                        }
+                        Log.d("samd experiment","aapt package end["+dexFileName+"]");
+
+                    }else{
+                        Log.d("samd experiment","aapt package start["+dexFileName+"]");
+                        IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+                        try {
+                            pm.aaptPackage("/collaboroid/agent/activity_res/"+dexFileName+"/res",
+                                    "/collaboroid/agent/activity_res/"+dexFileName+"/AndroidManifest.xml",
+                                    "/collaboroid/agent/activity_res/"+dexFileName+"/abc.apk");
+                        } catch (RemoteException e) {
+                            e.printStackTrace();
+                        }
+                        Log.d("samd experiment","aapt package end["+dexFileName+"]");
+                    }
+                    try{
+                        ISAMDService ss = ISAMDService.Stub.asInterface(ServiceManager.getService(Context.SAMD_SERVICE));
+                        ss.popUpActivity(dexFileName);
+                    }catch(RemoteException e){
+                        e.printStackTrace();
+                    }
+                } else if (input instanceof DexCode) {
+                    DexCode dexcode = (DexCode) input;
+
+                    SAMDService.remote_device_number = (int) dexcode.getPara().get(0);
+                    ArrayList<String> addResourcesPerActivity = new ArrayList<String>();
+                    Log.d("uuuuuuu_SAMDVSAPK", "multiDexTransfer getMultiDex receive : " + (String) dexcode.getPara().get(1));
+                    //File dexFiles = new File("/data/collaboroid/agent/dex/" + (String) request.getPara().get(j) + "_classes.dex");
+                    //DEX
+                    String dexFileName = (String) dexcode.getPara().get(1);
+                    Log.d("samd experiment","receive Dex & Resources : " + dexFileName);
+                    //PRE RESOURCES
+                    int preResourcesNum = (int) dexcode.getPara().get(3);
+                    //REAL RESOURCES
+                    int resourcesNum = (int) dexcode.getPara().get(4+preResourcesNum);
+
+                    File dexFiles = new File("/collaboroid/agent/dex/" + dexFileName + "_classes.dex");
+                    try {
+                        FileOutputStream fileOutputStream = new FileOutputStream(dexFiles);
+                        fileOutputStream.write((byte[]) dexcode.getPara().get(2));
+                        fileOutputStream.flush();
+                        fileOutputStream.close();
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                    }
+
+
+                    for (int i = 0, j = 4; i < preResourcesNum; i++, j ++) {
+                        //SBJ_A/res/drawable/a.png?
+                        String resDirectory = (String) dexcode.getPara().get(j);
+                        //add resources
+                        File src = new File("collaboroid/agent/activity_res/"+resDirectory);
+                        String dstResDirectory = resDirectory.replace(resDirectory.split("\\/")[0],dexFileName);
+                        Log.d("uuuuuuu_SAMDVSAPK","pre dstResDirectory : " + dstResDirectory);
+                        File dst = new File("collaboroid/agent/activity_res/"+dstResDirectory);
+                        copy(src, dst);
+                        addResourcesPerActivity.add(resDirectory);
+                    }
+
+                    for (int i = 0, j = 4+preResourcesNum+1; i < resourcesNum; i++, j += 2) {
+                        Log.d("uuuuuuu_SAMDVSAPK", "getResourcesLR receive : " + (String) dexcode.getPara().get(j));
+                        String activityResDirectory = (String) dexcode.getPara().get(j);
+                        //add resources
+                        addResourcesPerActivity.add(activityResDirectory);
+                        //create directory
+                        createDirAndFile(activityResDirectory,(byte[]) dexcode.getPara().get(j + 1));
+                    }
+
+
+                    AndroidManifestDummy(dexFileName);
+                    aaptForDexAsync afd = new aaptForDexAsync();
+                    afd.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, dexFileName);
+                    SAMDService.resourcesPerActivity.put(dexFileName, addResourcesPerActivity);
+
+
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+    }
+
+    public void terminate() {
+        try{
+            clientSocket.close();
+            inFromClient.close();
+            outToClient.close();
+        }catch (Exception e){
+            e.printStackTrace();
+        }
+    }
+
+    class aaptForDexAsync extends AsyncTask<String,Void, String> {
+        @Override
+        protected void onPreExecute() {
+            super.onPreExecute();
+        }
+
+        @Override
+        protected String doInBackground(String... strings) {
+            //collaboroid
+            String dexFile = strings[0];
+
+            Log.d("aaptTask","aapt task void : " + dexFile);
+            String dexName = dexFile;
+            File f = new File("collaboroid/agent/activity_res/"+dexName+"/assets");
+            if(f.exists()){
+                Log.d("samd experiment","aapt package start["+dexName+"]");
+                IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+                try {
+                    pm.aaptPackageWithAssets("/collaboroid/agent/activity_res/"+dexName+"/res",
+                            "collaboroid/agent/activity_res/"+dexName+"/assets",
+                            "/collaboroid/agent/activity_res/"+dexName+"/AndroidManifest.xml",
+                            "/collaboroid/agent/activity_res/"+dexName+"/abc.apk");
+                } catch (RemoteException e) {
+                    e.printStackTrace();
+                }
+                Log.d("samd experiment","aapt package end["+dexName+"]");
+
+            }else{
+                Log.d("samd experiment","aapt package start["+dexName+"]");
+                IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+                try {
+                    pm.aaptPackage("/collaboroid/agent/activity_res/"+dexName+"/res",
+                            "/collaboroid/agent/activity_res/"+dexName+"/AndroidManifest.xml",
+                            "/collaboroid/agent/activity_res/"+dexName+"/abc.apk");
+                } catch (RemoteException e) {
+                    e.printStackTrace();
+                }
+                Log.d("samd experiment","aapt package end["+dexName+"]");
+            }
+
+
+            if(SAMDService.callResourceStack.contains(dexName)){
+                try{
+                    Log.d("uuuuuuu_SAMDVSAPK", "SAMDService.callResourceStack : "+ dexName+" is in stack... so call ["+dexName+"]");
+                    ISAMDService ss = ISAMDService.Stub.asInterface(ServiceManager.getService(Context.SAMD_SERVICE));
+                    ss.popUpActivity(dexName);
+                }catch(RemoteException e){
+                    e.printStackTrace();
+                }
+            }
+            return null;
+        }
+        @Override
+        protected void onPostExecute(String string) {
+            super.onPostExecute(string);
+        }
+        // AsyncTask.cancel(boolean) 메소드가 true 인자로
+        // 실행되면 호출되는 콜백.
+        // background 작업이 취소될때 꼭 해야될 작업은  여기에 구현.
+        @Override
+        protected void onCancelled() {
+            // TODO Auto-generated method stub
+            super.onCancelled();
+        }
+    }
+
+
+    public void copy(File src, File dst) throws IOException{
+        String dir = dst.getAbsolutePath();
+        Log.d("uuuuuuu_DexCode","dir check : " +dir);
+        String pathSplit[] = dir.split("/");
+        String baseDir = "/";
+        for (int z = 1; z < pathSplit.length; z++) {
+            if(pathSplit[z].contains(".png") || pathSplit[z].contains(".xml")
+                    || pathSplit[z].contains(".jpg") || pathSplit[z].contains(".jpeg")){
+                baseDir += pathSplit[z];
+            }else{
+                baseDir += pathSplit[z] +"/";
+                File directory = new File(baseDir);
+                if (!directory.exists()) {
+                    directory.mkdir();
+                }
+            }
+            Log.d("uuuuuuu_DexCode", "copy baseDir : : " + baseDir);
+        }
+        InputStream in = new FileInputStream(src);
+        try{
+            OutputStream out = new FileOutputStream(dst);
+            try{
+                byte[] buf = new byte[4096];
+                int len;
+                while( (len=in.read(buf)) > 0){
+                    out.write(buf, 0, len);
+                }
+            }finally {
+                out.close();
+
+            }
+        }finally {
+            in.close();
+        }
+    }
+
+    public void createDirAndFile(String dir, byte[] dexByte){
+        String pathSplit[] = dir.split("/");
+        String baseDir = "/collaboroid/agent/activity_res/";
+        for (int z = 0; z < pathSplit.length; z++) {
+            if(pathSplit[z].contains(".png") || pathSplit[z].contains(".xml")
+                    || pathSplit[z].contains(".jpg") || pathSplit[z].contains(".jpeg")){
+                baseDir += pathSplit[z];
+                File activityResFile = new File("/collaboroid/agent/activity_res/" + dir);
+                try {
+                    //activity res
+                    FileOutputStream fileOutputStream = new FileOutputStream(activityResFile);
+                    fileOutputStream.write(dexByte);
+                    fileOutputStream.flush();
+                    fileOutputStream.close();
+                } catch (Exception e) {
+                    e.printStackTrace();
+                }
+            }else{
+                baseDir += pathSplit[z] +"/";
+                File directory = new File(baseDir);
+                if (!directory.exists()) {
+                    directory.mkdir();
+                }
+            }
+            Log.d("uuuuuuu_DexCode", "baseDir : : " + baseDir);
+        }
+    }
+    public void copyDirectoryOneLocationToAnotherLocation(File sourceLocation, File targetLocation)
+            throws IOException{
+        if(sourceLocation.isDirectory()){
+            if(!targetLocation.exists()){
+                targetLocation.mkdir();
+            }
+
+            String[] children = sourceLocation.list();
+            for(int i=0; i<sourceLocation.listFiles().length; i++){
+                copyDirectoryOneLocationToAnotherLocation(new File(sourceLocation, children[i]),
+                        new File(targetLocation, children[i]));
+            }
+        }else{
+            InputStream in = new FileInputStream(sourceLocation);
+            OutputStream out = new FileOutputStream(targetLocation);
+
+            byte[] buf = new byte[4096];
+            int len;
+            while((len=in.read(buf))>0){
+                out.write(buf,0,len);
+            }
+            in.close();
+            out.close();
+        }
+    }
+
+    public void AndroidManifestDummy(String dexName) {
+        String[] DummyxmlLine =
+                {"<?xml version=\"1.0\" encoding=\"utf-8\"?>",
+                        "<manifest xmlns:android=\"http://schemas.android.com/apk/res/android\"",
+                        "package=\"com.collaboroid.dummy1\">",
+                        "android:versionCode=\"1\"",
+                        "android:versionName=\"1.0\"",
+                        "<uses-permission android:name=\"android.permission.INTERNET\"/>",
+                        "<uses-permission android:name=\"android.permission.KILL_BACKGROUND_PROCESSES\"/>",
+                        "<application",
+                        "android:icon=\"@drawable/ic_launcher\"",
+                        "android:label=\"@string/Main_title\">",
+                        "<activity android:name=\".MainActivity\"",
+                        "android:label=\"@string/Main_title\"",
+                        "android:launchMode=\"singleTask\"",
+                        "android:clearTaskOnLaunch=\"true\">",
+                        "<intent-filter>",
+                        "<action android:name=\"android.intent.action.MAIN\" />",
+                        "<category android:name=\"android.intent.category.LAUNCHER\" />",
+                        "</intent-filter>",
+                        "</activity>",
+                        "</application>",
+                        "</manifest>"};
+        String dummy1FileName = "/collaboroid/agent/activity_res/"+dexName+"/AndroidManifest.xml";
+        BufferedWriter bw = null;
+        try {
+            bw = new BufferedWriter(new FileWriter(dummy1FileName));
+            for(int i=0; i<DummyxmlLine.length; i++){
+                bw.write(DummyxmlLine[i]);
+                bw.newLine();
+
+            }
+        } catch (IOException e) {
+            e.printStackTrace();
+        } finally{
+            try {
+                if (bw != null)
+                    bw.close();
+            } catch (IOException e) {
+
+            }
+        }
+    }
+}
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/MainLooperSpy.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/MainLooperSpy.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/MainLooperSpy.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/MainLooperSpy.java	2017-01-29 02:51:16.649856000 +0900
@@ -0,0 +1,48 @@
+package com.android.server.remote;
+
+import java.lang.reflect.Field;
+
+import android.os.Looper;
+import android.os.Message;
+import android.os.MessageQueue;
+import android.util.Log;
+
+public class MainLooperSpy {
+	  private final Field messagesField;
+	  private final Field nextField;
+	  private final MessageQueue mainMessageQueue;
+
+	  public MainLooperSpy() {
+	    try {
+	      Field queueField = Looper.class.getDeclaredField("mQueue");
+	      queueField.setAccessible(true);
+	      messagesField = MessageQueue.class.getDeclaredField("mMessages");
+	      messagesField.setAccessible(true);
+	      nextField = Message.class.getDeclaredField("next");
+	      nextField.setAccessible(true);
+	      Looper mainLooper = Looper.getMainLooper();
+	      mainMessageQueue = (MessageQueue) queueField.get(mainLooper);
+	    } catch (Exception e) {
+	      throw new RuntimeException(e);
+	    }
+	  }
+
+	  public void dumpQueue() {
+	    try {
+	      Message nextMessage = (Message) messagesField.get(mainMessageQueue);
+	      Log.d("MainLooperSpy", "Begin dumping queue");
+	      dumpMessages(nextMessage);
+	      Log.d("MainLooperSpy", "End dumping queue");
+	    } catch (IllegalAccessException e) {
+	      throw new RuntimeException(e);
+	    }
+	  }
+
+	  public void dumpMessages(Message message) throws IllegalAccessException {
+	    if (message != null) {
+	      Log.d("MainLooperSpy", message.toString());
+	      Message next = (Message) nextField.get(message);
+	      dumpMessages(next);
+	    }
+	  }
+	}
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/ObjectSizeCalculator.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/ObjectSizeCalculator.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/ObjectSizeCalculator.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/ObjectSizeCalculator.java	2017-01-29 02:51:16.641856000 +0900
@@ -0,0 +1,190 @@
+package com.android.server.remote;
+
+import java.lang.reflect.Field;
+import java.lang.reflect.Modifier;
+import java.util.HashSet;
+import java.util.Set;
+
+public class ObjectSizeCalculator
+{
+
+	private static final int REFERENCE_SIZE;
+	private static final int HEADER_SIZE;
+	private static final int LONG_SIZE = 8;
+	private static final int INT_SIZE = 4;
+	private static final int BYTE_SIZE = 1;
+	private static final int BOOLEAN_SIZE = 1;
+	private static final int CHAR_SIZE = 2;
+	private static final int SHORT_SIZE = 2;
+	private static final int FLOAT_SIZE = 4;
+	private static final int DOUBLE_SIZE = 8;
+	private static final int ALIGNMENT = 8;
+
+	static
+	{
+		try
+		{
+			if (System.getProperties().get("java.vm.name").toString()
+					.contains("64"))
+			{
+				// java.vm.name is something like “Java HotSpot(TM) 64-Bit
+				// Server VM”
+				REFERENCE_SIZE = 8;
+				HEADER_SIZE = 16;
+			} else
+			{
+				REFERENCE_SIZE = 4;
+				HEADER_SIZE = 8;
+			}
+		} catch (Exception ex)
+		{
+			ex.printStackTrace();
+			throw new AssertionError(ex);
+		}
+	}
+
+	public static long sizeOf(Object o) throws IllegalAccessException
+	{
+		return sizeOf(o, new HashSet());
+	}
+
+	private static long sizeOf(Object o, Set visited)
+			throws IllegalAccessException
+	{
+		if (o == null)
+		{
+			return 0;
+		}
+		ObjectWrapper objectWrapper = new ObjectWrapper(o);
+		if (visited.contains(objectWrapper))
+		{
+			// We have reference graph with cycles.
+			return 0;
+		}
+		visited.add(objectWrapper);
+		long size = HEADER_SIZE;
+		Class clazz = o.getClass();
+		if (clazz.isArray())
+		{
+			if (clazz == long[].class)
+			{
+				long[] objs = (long[]) o;
+				size += objs.length * LONG_SIZE;
+			} else if (clazz == int[].class)
+			{
+				int[] objs = (int[]) o;
+				size += objs.length * INT_SIZE;
+			} else if (clazz == byte[].class)
+			{
+				byte[] objs = (byte[]) o;
+				size += objs.length * BYTE_SIZE;
+			} else if (clazz == boolean[].class)
+			{
+				boolean[] objs = (boolean[]) o;
+				size += objs.length * BOOLEAN_SIZE;
+			} else if (clazz == char[].class)
+			{
+				char[] objs = (char[]) o;
+				size += objs.length * CHAR_SIZE;
+			} else if (clazz == short[].class)
+			{
+				short[] objs = (short[]) o;
+				size += objs.length * SHORT_SIZE;
+			} else if (clazz == float[].class)
+			{
+				float[] objs = (float[]) o;
+				size += objs.length * FLOAT_SIZE;
+			} else if (clazz == double[].class)
+			{
+				double[] objs = (double[]) o;
+				size += objs.length * DOUBLE_SIZE;
+			} else
+			{
+				Object[] objs = (Object[]) o;
+				for (int i = 0; i < objs.length; i++)
+				{
+					size += sizeOf(objs[i], visited) + REFERENCE_SIZE;
+				}
+			}
+			size += INT_SIZE;
+		} else
+		{
+			Field[] fields = o.getClass().getDeclaredFields();
+			for (int i = 0; i < fields.length; i++)
+			{
+				if (Modifier.isStatic(fields[i].getModifiers()))
+				{
+					continue;
+				}
+				fields[i].setAccessible(true);
+				String fieldType = fields[i].getGenericType().toString();
+				if (fieldType.equals("long"))
+				{
+					size += LONG_SIZE;
+				} else if (fieldType.equals("int"))
+				{
+					size += INT_SIZE;
+				} else if (fieldType.equals("byte"))
+				{
+					size += BYTE_SIZE;
+				} else if (fieldType.equals("boolean"))
+				{
+					size += BOOLEAN_SIZE;
+				} else if (fieldType.equals("char"))
+				{
+					size += CHAR_SIZE;
+				} else if (fieldType.equals("short"))
+				{
+					size += SHORT_SIZE;
+				} else if (fieldType.equals("float"))
+				{
+					size += FLOAT_SIZE;
+				} else if (fieldType.equals("double"))
+				{
+					size += DOUBLE_SIZE;
+				} else
+				{
+					size += sizeOf(fields[i].get(o), visited) + REFERENCE_SIZE;
+				}
+			}
+		}
+		if ((size % ALIGNMENT) != 0)
+		{
+			size = ALIGNMENT * (size / ALIGNMENT) + ALIGNMENT;
+		}
+		return size;
+	}
+
+	private static final class ObjectWrapper
+	{
+
+		private Object object;
+
+		public ObjectWrapper(Object object)
+		{
+			this.object = object;
+		}
+
+		@Override
+		public boolean equals(Object obj)
+		{
+			if (obj == this)
+			{
+				return true;
+			}
+			if ((obj == null) || (obj.getClass() != ObjectWrapper.class))
+			{
+				return false;
+			}
+			return object == ((ObjectWrapper) obj).object;
+		}
+
+		@Override
+		public int hashCode()
+		{
+			int hash = 3;
+			hash = 47 * hash + System.identityHashCode(object);
+			return hash;
+		}
+	}
+}
